# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "diana"


def test_query(self):
    result = self.decode(
        """H|\\^&|||WADIANA^0000711^ERY|||||||P|1|20140415175620
    Q|1|ALL||ALL||||||||I|
    L|1|N"""
    )
    expected = {
        "context": "query",
        "samples": [{"sample_id": "ALL", "type": "patient"}],
    }
    assert result == expected


def test_order(self):
    result = self.order()
    expected = """H|\\^&||||||||||P|1|20130715141912
        P|1|036666666|||NYME^ANO|NJF|20110513|F
        O|1|123456||^^^A|R||||||A||||||||||||||O
        O|2|123456||^^^B|R||||||A||||||||||||||O
        L|1|N"""
    assert result == expected


def test_result(self):
    result = self.decode(
        """H|\\^&|||DIANA|||||LIS||P|1|199810151610
        P|1|3027|||PARISIS^ELisabeth||19670421|F
        O|1|42603027||^^^11145|R||||||A||||40||||||||||F
        R|1|^^^GSABO^^^^F|AB|||||F||||20131009115236
        L|1|N"""
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "sample_id": "42603027",
                "type": "patient",
                "results": [
                    {
                        "date": datetime.datetime(2013, 10, 9, 11, 52, 36),
                        "value": "AB",
                        "code": "GSABO",
                    }
                ],
            }
        ],
    }
    assert result == expected
